//
//  TwitterViewViewViewController.m
//  TwitterViewView
//
//  Created by Ichi Kanaya on 10/11/03.
//  Copyright 2010 __MyCompanyName__. All rights reserved.
//

#import <stdlib.h>
#import "TwitterViewViewViewController.h"
#import "TwitterView.h"
#import "URLLoader.h"
#import "StatusXMLParser.h"


@implementation TwitterViewViewViewController

@synthesize statuses;
@synthesize aRandomNumber;


/*
// The designated initializer. Override to perform setup that is required before the view is loaded.
- (id)initWithNibName:(NSString *)nibNameOrNil bundle:(NSBundle *)nibBundleOrNil {
    if ((self = [super initWithNibName:nibNameOrNil bundle:nibBundleOrNil])) {
        // Custom initialization
    }
    return self;
}
*/

/*
// Implement loadView to create a view hierarchy programmatically, without using a nib.
- (void)loadView {
}
*/


// Implement viewDidLoad to do additional setup after loading the view, typically from a nib.
- (void)viewDidLoad {
	[super viewDidLoad];
	label = [[UILabel alloc] init];
	[label setText: @"Twitter検索中..."];
	[label sizeToFit];
	scrollView.contentSize = label.frame.size;
	[scrollView addSubview: label];
	[self loadTimeLine];
}


/*
// Override to allow orientations other than the default portrait orientation.
- (BOOL)shouldAutorotateToInterfaceOrientation:(UIInterfaceOrientation)interfaceOrientation {
    // Return YES for supported orientations
    return (interfaceOrientation == UIInterfaceOrientationPortrait);
}
*/

- (void)didReceiveMemoryWarning {
	// Releases the view if it doesn't have a superview.
    [super didReceiveMemoryWarning];
	
	// Release any cached data, images, etc that aren't in use.
}

- (void)viewDidUnload {
	// Release any retained subviews of the main view.
	// e.g. self.myOutlet = nil;
}


- (void)dealloc {
	[label release];
	[super dealloc];
}


- (void)loadTimeLine {
	static NSString *url = @"http://search.twitter.com/search.atom?lang=ja&q=%23koiwarai";
	URLLoader *loder = [[[URLLoader alloc] init] autorelease];
	[[NSNotificationCenter defaultCenter] addObserver: self                         
																					 selector: @selector(loadTimeLineDidEnd:)
																							 name: @"connectionDidFinishNotification"
																						 object: loder];
	[[NSNotificationCenter defaultCenter] addObserver: self
																					 selector: @selector(loadTimeLineFailed:)
																							 name: @"connectionDidFailWithError"
																						 object: loder];
	[UIApplication sharedApplication].networkActivityIndicatorVisible = YES;
	[loder loadFromUrl: url method: @"GET"];
}


- (void)loadTimeLineDidEnd: (NSNotification *)notification {
	[UIApplication sharedApplication].networkActivityIndicatorVisible = NO;
	
	URLLoader *loder = (URLLoader *)[notification object];
	NSData *xmlData = loder.data;
	
	NSLog(@"%@", [[NSString alloc] initWithData: xmlData encoding: NSUTF8StringEncoding]);
	
	// StatusXMLParser *parser = [[[StatusXMLParser alloc] init] autorelease];
	StatusXMLParser *parser = [[StatusXMLParser alloc] init] ;
	// [parser setDelegate: parser];
	self.statuses = [parser parseStatuses: xmlData];
	self.aRandomNumber = rand() % [self.statuses count];
	[self updateTimeLine];
}


- (void)loadTimeLineFailed: (NSNotification *)notification {
	[UIApplication sharedApplication].networkActivityIndicatorVisible = NO;
	

	// alertViewを使い回している．よくない．
	// should simply ignore this error
	UIAlertView *alert = [[UIAlertView alloc] initWithTitle: @"ERROR"  
																									message: @"Failed to get time line"  
																								 delegate: self
																				cancelButtonTitle: @"Close"  
																				otherButtonTitles: nil];
	[alert show];
	[alert release];
}

- (void)updateTimeLine {
	NSString *text = [[self.statuses objectAtIndex: self.aRandomNumber] objectForKey: @"text"];
	[label setText: text];
	[label sizeToFit];
	scrollView.contentSize = label.frame.size;
}

- (IBAction)reload: (id)sender {
	[self loadTimeLine];
}

- (IBAction)showTwitterWeb: (id)sender {
	// open a alert with an OK and cancel button
	UIAlertView *alert = [[UIAlertView alloc] initWithTitle: @"ツイッター" 
																									message: @"Safariで続きを読みますか？"
																								 delegate: self
																				cancelButtonTitle: @"いいえ" 
																				otherButtonTitles: @"はい", nil];
	[alert show];
	[alert release];
}

- (void)alertView: (UIAlertView *)actionSheet clickedButtonAtIndex: (NSInteger)buttonIndex {
	if (buttonIndex == 1) {
		NSURL *link = [[self.statuses objectAtIndex: aRandomNumber] objectForKey: @"link"];
		[[UIApplication sharedApplication] openURL: link];
	}
}



@end
