//
//  URLLoader.m
//  TwitterViewer
//
//  Created by Ichi Kanaya on 10/11/01.
//  This code is based on sample code at http://www.atmarkit.co.jp/fwcr/design/tool/iphonesdk04/01.html
//

#import "URLLoader.h"

@implementation URLLoader

@synthesize connection;
@synthesize data;

- (void)connection: (NSURLConnection *)connection didReceiveResponse: (NSURLResponse *)response {
	self.data = [NSMutableData data];
}

-(void)connection: (NSURLConnection *)connection didReceiveData: (NSData *)receiveData {
	[self.data appendData:receiveData];
}

- (void)connectionDidFinishLoading: (NSURLConnection *)connection {
	[[NSNotificationCenter defaultCenter] postNotificationName: @"connectionDidFinishNotification" 
																											object: self];
}

- (void)connection: (NSURLConnection *)connection didFailWithError: (NSError *)error {
	[[NSNotificationCenter defaultCenter] postNotificationName: @"connectionDidFailWithError" 
																											object: self];
}

- (void)loadFromUrl: (NSString *)url method: (NSString *) method {
	NSMutableURLRequest *req = [NSMutableURLRequest requestWithURL: [NSURL URLWithString: url]];
	[req setHTTPMethod: method];
	self.connection = [NSURLConnection connectionWithRequest: req 
																									delegate: self];
}

- (void)dealloc {
	[connection release];
	[data release];
	[super dealloc];
}

@end